#----------------------------------------------------------------------
# Title      : Example top level constraints for JESD204
# Project    : jesd204_v6_0
#----------------------------------------------------------------------
# File       : jd204bv6p0l2sc0_example_design.xdc
# Author     : Xilinx
#----------------------------------------------------------------------
# Description: Xilinx Constraint file for the example design for
#              JESD204 core
#---------------------------------------------------------------------
# (c) Copyright 2004-2014 Xilinx, Inc. All rights reserved.
#
# This file contains confidential and proprietary information
# of Xilinx, Inc. and is protected under U.S. and
# international copyright and other intellectual property
# laws.
#
# DISCLAIMER
# This disclaimer is not a license and does not grant any
# rights to the materials distributed herewith. Except as
# otherwise provided in a valid license issued to you by
# Xilinx, and to the maximum extent permitted by applicable
# law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
# WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
# AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
# BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
# INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
# (2) Xilinx shall not be liable (whether in contract or tort,
# including negligence, or under any other theory of
# liability) for any loss or damage of any kind or nature
# related to, arising under or in connection with these
# materials, including for any direct, or any indirect,
# special, incidental, or consequential loss or damage
# (including loss of data, profits, goodwill, or any type of
# loss or damage suffered as a result of any action brought
# by a third party) even if such damage or loss was
# reasonably foreseeable or Xilinx had been advised of the
# possibility of the same.
#
# CRITICAL APPLICATIONS
# Xilinx products are not designed or intended to be fail-
# safe, or for use in any application requiring fail-safe
# performance, such as life-support or safety devices or
# systems, Class III medical devices, nuclear facilities,
# applications related to the deployment of airbags, or any
# other applications that could lead to death, personal
# injury, or severe property or environmental damage
# (individually and collectively, "Critical
# Applications"). Customer assumes the sole risk and
# liability of any use of Xilinx products in Critical
# Applications, subject only to applicable laws and
# regulations governing limitations on product liability.
#
# THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
# PART OF THIS FILE AT ALL TIMES.
#

#------------------------------------------
# TIMING CONSTRAINTS
#------------------------------------------

# Set Reference Clock to 156MHz by default
create_clock -period 3.2 -name jd204bevl4sc0_refclk [get_ports refclk0p]
#create_clock -period 8.0 -name jd204bevl4sc0_refclk [get_ports refclk0p]
#create_clock -period 12.5 -name jd204bevl4sc0_refclk [get_ports refclk0p]

# Set Device Clock to 156MHz by default
# Set AXI-Lite Clock to 100MHz by default
create_clock -period 5.000 -waveform {0.000 2.500} [get_ports rx_sysclk_p]

create_clock -period 16.670 [get_ports fifoclk]
set_input_jitter [get_clocks fifoclk] 0.167

# Set +/- 0.5ns between the rising edges of the clock

#set_property PACKAGE_PIN Y23 [get_ports gte_clk]

set_property PACKAGE_PIN L21 [get_ports ssda]
set_property PACKAGE_PIN K21 [get_ports sscl]

set_property PACKAGE_PIN AD23 [get_ports actpls]
set_property PACKAGE_PIN Y30 [get_ports adflag]
set_property PACKAGE_PIN AA30 [get_ports cfgrst]
set_property PACKAGE_PIN AB30 [get_ports hostrw]

set_property PACKAGE_PIN AJ26 [get_ports {adport[0]}]
set_property PACKAGE_PIN AK26 [get_ports {adport[1]}]
set_property PACKAGE_PIN AG27 [get_ports {adport[2]}]
set_property PACKAGE_PIN AG28 [get_ports {adport[3]}]
set_property PACKAGE_PIN AG30 [get_ports {adport[4]}]
set_property PACKAGE_PIN AH30 [get_ports {adport[5]}]
set_property PACKAGE_PIN AE30 [get_ports {adport[6]}]
set_property PACKAGE_PIN AF30 [get_ports {adport[7]}]

set_property PACKAGE_PIN AC24 [get_ports txen]
set_property PACKAGE_PIN AD24 [get_ports wrn]

set_property PACKAGE_PIN AF20 [get_ports {fifo_data[0]}]
set_property PACKAGE_PIN AF21 [get_ports {fifo_data[1]}]
set_property PACKAGE_PIN AH21 [get_ports {fifo_data[2]}]
set_property PACKAGE_PIN AJ21 [get_ports {fifo_data[3]}]
set_property PACKAGE_PIN AG25 [get_ports {fifo_data[4]}]
set_property PACKAGE_PIN AH25 [get_ports {fifo_data[5]}]
set_property PACKAGE_PIN AE25 [get_ports {fifo_data[6]}]
set_property PACKAGE_PIN AF25 [get_ports {fifo_data[7]}]
set_property PACKAGE_PIN AF22 [get_ports fifoclk]

#set_property PACKAGE_PIN A18 [get_ports adcck]
set_property PACKAGE_PIN B19 [get_ports adcck]


#set_property PACKAGE_PIN B18 [get_ports adcdi]
set_property PACKAGE_PIN C19 [get_ports adcdi]
set_property PACKAGE_PIN A28 [get_ports adcdo]

set_property PACKAGE_PIN B28 [get_ports adccsa]
set_property PACKAGE_PIN E29 [get_ports adccsb]
set_property PACKAGE_PIN C20 [get_ports clkgencs]
set_property PACKAGE_PIN E19 [get_ports s6954cs]
set_property PACKAGE_PIN H21 [get_ports sysrefcs]

# Jack Brown Board
#set_property PACKAGE_PIN G17 [get_ports adcck]
#set_property PACKAGE_PIN B18 [get_ports adccs]
#set_property PACKAGE_PIN A17 [get_ports adcdi]
#set_property PACKAGE_PIN A16 [get_ports adcdo]

set_property PACKAGE_PIN AE28 [get_ports miso]
set_property PACKAGE_PIN AD26 [get_ports mosi]

set_property PACKAGE_PIN AG29 [get_ports sck]
set_property PACKAGE_PIN AF28 [get_ports scs]

set_property PACKAGE_PIN AE26 [get_ports rx_aresetn]
set_property PACKAGE_PIN AC6 [get_ports rx_reset]

set_property PACKAGE_PIN C8 [get_ports refclk0p]
set_property PACKAGE_PIN C7 [get_ports refclk0n]

set_property PACKAGE_PIN C29 [get_ports rx_sync_p]
set_property PACKAGE_PIN B29 [get_ports rx_sync_n]

set_property PACKAGE_PIN D22 [get_ports rx1_sync_p]
set_property PACKAGE_PIN C22 [get_ports rx1_sync_n]

set_property PACKAGE_PIN H25 [get_ports rx2_sync_n]
set_property PACKAGE_PIN H24 [get_ports rx2_sync_p]


set_property PACKAGE_PIN AD11 [get_ports rx_sysclk_n]
set_property PACKAGE_PIN AD12 [get_ports rx_sysclk_p]

set_property PACKAGE_PIN D16 [get_ports sref_sync]
set_property PACKAGE_PIN A11 [get_ports rclk_sync]

#set_property IOSTANDARD LVCMOS25 [get_ports gte_clk]

set_property IOSTANDARD LVCMOS25 [get_ports ssda]
set_property IOSTANDARD LVCMOS25 [get_ports sscl]

set_property IOSTANDARD LVCMOS25 [get_ports actpls]
set_property IOSTANDARD LVCMOS25 [get_ports adflag]
set_property IOSTANDARD LVCMOS25 [get_ports cfgrst]
set_property IOSTANDARD LVCMOS25 [get_ports hostrw]

set_property IOSTANDARD LVCMOS25 [get_ports {adport[0]}]
set_property IOSTANDARD LVCMOS25 [get_ports {adport[1]}]
set_property IOSTANDARD LVCMOS25 [get_ports {adport[2]}]
set_property IOSTANDARD LVCMOS25 [get_ports {adport[3]}]
set_property IOSTANDARD LVCMOS25 [get_ports {adport[4]}]
set_property IOSTANDARD LVCMOS25 [get_ports {adport[5]}]
set_property IOSTANDARD LVCMOS25 [get_ports {adport[6]}]
set_property IOSTANDARD LVCMOS25 [get_ports {adport[7]}]

set_property IOSTANDARD LVCMOS25 [get_ports txen]
set_property IOSTANDARD LVCMOS25 [get_ports wrn]

set_property IOSTANDARD LVCMOS25 [get_ports {fifo_data[0]}]
set_property IOSTANDARD LVCMOS25 [get_ports {fifo_data[1]}]
set_property IOSTANDARD LVCMOS25 [get_ports {fifo_data[2]}]
set_property IOSTANDARD LVCMOS25 [get_ports {fifo_data[3]}]
set_property IOSTANDARD LVCMOS25 [get_ports {fifo_data[4]}]
set_property IOSTANDARD LVCMOS25 [get_ports {fifo_data[5]}]
set_property IOSTANDARD LVCMOS25 [get_ports {fifo_data[6]}]
set_property IOSTANDARD LVCMOS25 [get_ports {fifo_data[7]}]
set_property IOSTANDARD LVCMOS25 [get_ports fifoclk]

set_property IOSTANDARD LVCMOS25 [get_ports adcck]

set_property IOSTANDARD LVCMOS25 [get_ports adccsa]
set_property IOSTANDARD LVCMOS25 [get_ports adccsb]
set_property IOSTANDARD LVCMOS25 [get_ports sysrefcs]
set_property IOSTANDARD LVCMOS25 [get_ports clkgencs]
set_property IOSTANDARD LVCMOS25 [get_ports s6954cs]

set_property IOSTANDARD LVCMOS25 [get_ports adcdi]
set_property IOSTANDARD LVCMOS25 [get_ports adcdo]

set_property IOSTANDARD LVCMOS25 [get_ports miso]
set_property IOSTANDARD LVCMOS25 [get_ports mosi]
set_property IOSTANDARD LVCMOS25 [get_ports sck]
set_property IOSTANDARD LVCMOS25 [get_ports scs]

set_property IOSTANDARD LVCMOS25 [get_ports sref_sync]
set_property IOSTANDARD LVCMOS25 [get_ports rclk_sync]

set_property IOSTANDARD LVCMOS25 [get_ports rx_aresetn]
set_property IOSTANDARD LVCMOS15 [get_ports rx_reset]

set_property IOSTANDARD LVDS_25 [get_ports rx_sync_p]
set_property IOSTANDARD LVDS_25 [get_ports rx_sync_n]

set_property IOSTANDARD LVDS_25 [get_ports rx1_sync_p]
set_property IOSTANDARD LVDS_25 [get_ports rx1_sync_n]

set_property IOSTANDARD LVDS_25 [get_ports rx2_sync_p]
set_property IOSTANDARD LVDS_25 [get_ports rx2_sync_n]


set_property IOSTANDARD DIFF_SSTL15 [get_ports rx_sysclk_p]
set_property IOSTANDARD DIFF_SSTL15 [get_ports rx_sysclk_n]



set_property DIFF_TERM TRUE [get_ports rx_sysclk_p]
set_property DIFF_TERM TRUE [get_ports rx_sysclk_n]


#set_property CLOCK_DEDICATED_ROUTE FALSE [get_nets sck_IBUF]

#set_property CLOCK_DEDICATED_ROUTE TRUE [get_nets sck_IBUF]
#set_property CLOCK_DEDICATED_ROUTE TRUE [get_nets actpls_IBUF]

# Linear Tech Demo Board
#set_property LOC GTXE2_CHANNEL_X0Y12 [get_cells i_jesd204_v4p0_block/inst/i_gtwizard_v2_5_top/gtwizard_v2_5_0_i/inst/gt0_gtwizard_v2_5_0_i/gtxe2_i]
set_property PACKAGE_PIN E4 [get_ports {rxp[0]}]
set_property PACKAGE_PIN E3 [get_ports {rxn[0]}]

# Analog Devices Demo Board
#set_property LOC GTXE2_CHANNEL_X0Y12 [get_cells i_jesd204_v4p0_block/inst/i_gtwizard_v2_5_top/gtwizard_v2_5_0_i/inst/gt0_gtwizard_v2_5_0_i/gtxe2_i]
#set_property PACKAGE_PIN D6 [get_ports {rxp[0]}]
#set_property PACKAGE_PIN D5 [get_ports {rxn[0]}]

#set_property LOC GTXE2_CHANNEL_X0Y14 [get_cells i_jesd204_v4p0_block/inst/i_gtwizard_v2_5_top/gtwizard_v2_5_0_i/inst/gt1_gtwizard_v2_5_0_i/gtxe2_i]
set_property PACKAGE_PIN B6 [get_ports {rxp[1]}]
set_property PACKAGE_PIN B5 [get_ports {rxn[1]}]

create_generated_clock -name axi_mclk -source [get_pins clk_wiz_rx_sysclk/CLK_IN1] -divide_by 2 [get_pins clk_wiz_rx_sysclk/CLK_OUT1]

create_generated_clock -name coreclk -source [get_pins clk_wiz_rx_aclk_2/CLK_IN1] -multiply_by 1 [get_pins clk_wiz_rx_aclk_2/CLK_OUT1]
create_generated_clock -name clkdb2 -source [get_pins clk_wiz_rx_aclk_2/CLK_IN1] -divide_by 2 [get_pins clk_wiz_rx_aclk_2/CLK_OUT2]
create_generated_clock -name bram_aclk -source [get_pins clk_wiz_rx_aclk_2/CLK_IN1] -multiply_by 1 [get_pins clk_wiz_rx_aclk_2/CLK_OUT3]
create_generated_clock -name bram_bclk -source [get_pins clk_wiz_rx_fclk/clk_in1] -divide_by 1 [get_pins clk_wiz_rx_fclk/clk_out1]

create_clock -period 100.000 -name actpls_clk -waveform {0.000 50.000} [get_ports actpls]
#create_clock -period 0.320 -name QPLLOUTCLK -waveform {0.000 0.160} [get_pins i_jesd204_v4p0_block/inst/i_gtwizard_v2_5_top/gtwizard_v2_5_0_i/inst/gtxe2_common_0_i/QPLLOUTCLK]
#create_clock -period 6.400 -name QPLLOUTREFCLK -waveform {0.000 3.200} [get_pins i_jesd204_v4p0_block/inst/i_gtwizard_v2_5_top/gtwizard_v2_5_0_i/inst/gtxe2_common_0_i/QPLLOUTREFCLK]
#create_clock -period 6.400 -name RXOUTCLK -waveform {0.000 3.200} [get_pins i_jesd204_v4p0_block/inst/i_gtwizard_v2_5_top/gtwizard_v2_5_0_i/inst/gt0_gtwizard_v2_5_0_i/gtxe2_i/RXOUTCLK]


set_property SLEW FAST [get_ports wrn]
set_property SLEW FAST [get_ports rx_aresetn]
set_property SLEW FAST [get_ports miso]
set_property SLEW FAST [get_ports adcdi]

set_property SLEW FAST [get_ports adccsa]
set_property SLEW FAST [get_ports adccsb]
set_property SLEW FAST [get_ports clkgencs]
set_property SLEW FAST [get_ports sysrefcs]
set_property SLEW FAST [get_ports s6954cs]

set_property SLEW FAST [get_ports adcck]

set_property SLEW FAST [get_ports rclk_sync]
set_property SLEW FAST [get_ports sref_sync]

set_property PULLUP true [get_ports txen]
set_property PULLDOWN true [get_ports adflag]
set_property PULLUP true [get_ports cfgrst]
set_property PULLDOWN true [get_ports hostrw]
set_property PULLDOWN true [get_ports actpls]


set_false_path -from [get_pins ftdi_cfg/START_SET_reg/C] -to [get_pins SYNCERR_DET_reg/CLR]
set_false_path -from [get_clocks refclk] -to [get_clocks actpls_clk]
set_false_path -from [get_clocks bram_aclk] -to [get_clocks actpls_clk]
set_false_path -from [get_clocks clkdb2] -to [get_clocks actpls_clk]
set_false_path -from [get_clocks clkdb2] -to [get_clocks bram_bclk]
set_false_path -from [get_clocks actpls_clk] -to [get_clocks clkdb2]
set_false_path -from [get_clocks coreclk] -to [get_clocks actpls_clk]
set_false_path -from [get_clocks coreclk] -to [get_clocks axi_mclk]
set_false_path -from [get_clocks actpls_clk] -to [get_clocks bram_aclk]
set_false_path -from [get_clocks actpls_clk] -to [get_clocks fifoclk]
#set_false_path -from [get_clocks bram_aclk] -to [get_clocks clk_out1_clk_wiz_rx_fclk]
set_false_path -from [get_clocks bram_aclk] -to [get_clocks fifoclk]
set_false_path -from [get_clocks bram_aclk] -to [get_clocks axi_mclk]
set_false_path -from [get_clocks bram_aclk] -to [get_clocks bram_bclk]
set_false_path -from [get_clocks actpls_clk] -to [get_clocks bram_bclk]
set_false_path -from [get_clocks bram_bclk] -to [get_clocks actpls_clk]
set_false_path -from [get_ports rx_reset] -to [get_clocks actpls_clk]

## set_false_path [get_ports rx_reset] -to [get_clocks *]
#gyu
set_false_path -from [get_ports rx_reset] -to [get_pins {xlbram_b_addr/addr_reg[*]/CLR}]
set_false_path -from [get_ports rx_reset] -to [get_pins {xlbram_ctrl/capture_reg_reg[*]/CLR}]
set_false_path -from [get_ports rx_reset] -to [get_pins {xlbram_ctrl/capture_sp_reg_reg[*]/CLR}]
#set_false_path -from [get_ports rx_reset] -to [get_pins xlbram_ctrl/capture_reg_reg_c_*/CLR]
set_false_path -from [get_ports rx_reset] -to [get_pins {xlbram_a_addr/addr_reg[*]/CLR}]
#gyu
set_false_path -from [get_ports cfgrst] -to [get_pins {xlbram_b_addr/addr_reg[*]/CLR}]
set_false_path -from [get_ports cfgrst] -to [get_pins {xlbram_ctrl/capture_reg_reg[*]/CLR}]
set_false_path -from [get_ports cfgrst] -to [get_pins {xlbram_ctrl/capture_sp_reg_reg[*]/CLR}]
#set_false_path -from [get_ports cfgrst] -to [get_pins xlbram_ctrl/capture_reg_reg_c_*/CLR]
set_false_path -from [get_ports cfgrst] -to [get_pins {xlbram_a_addr/addr_reg[*]/CLR}]
#gyu

# output delay
set_output_delay -clock [get_clocks actpls_clk] 5.0 [get_ports ssda]
set_output_delay -clock [get_clocks actpls_clk] 5.0 [get_ports sscl]

set_output_delay -clock [get_clocks bram_bclk] 3.0 [get_ports {fifo_data[*]}]
set_output_delay -clock [get_clocks bram_bclk] 3.0 [get_ports wrn]

set_output_delay -clock [get_clocks actpls_clk] 5.0 [get_ports {adport[*]}]

# input delay
set_input_delay -clock [get_clocks actpls_clk] 5.0 [get_ports ssda]

set_input_delay -clock [get_clocks bram_bclk] 5.0 [get_ports txen]
set_input_delay -clock [get_clocks actpls_clk] 5.0 [get_ports hostrw]
set_input_delay -clock [get_clocks actpls_clk] 5.0 [get_ports adflag]
set_input_delay -clock [get_clocks actpls_clk] 5.0 [get_ports {adport[*]}]

#pad to pad
set_max_delay -from [get_ports sck] -to [get_ports adcck] 8.4

set_max_delay -from [get_ports scs] -to [get_ports s6954cs] 8.700
set_max_delay -from [get_ports scs] -to [get_ports adccsa] 8.300
set_max_delay -from [get_ports scs] -to [get_ports adccsb] 8.300
set_max_delay -from [get_ports scs] -to [get_ports clkgencs] 8.700
set_max_delay -from [get_ports scs] -to [get_ports sysrefcs] 8.900


set_max_delay -from [get_ports mosi] -to [get_ports adcdi] 8.4
set_max_delay -from [get_ports adcdo] -to [get_ports miso] 8.0

set_max_delay -from [get_clocks coreclk] -to [get_clocks bram_aclk] 3.5
set_max_delay -from [get_clocks actpls_clk] -to [get_clocks axi_mclk] 2.5
set_max_delay -from [get_clocks axi_mclk] -to [get_clocks actpls_clk] 3.5



# Set Reference to 156.250MHz by default
#create_clock -period 6.400 -name jd204bv6p0l2sc0_refclk [get_ports refclk0p]



# Set AXI-Lite Clock to 170MHz by default
#create_clock -period 5.8 -name jd204bv6p0l2sc0_axi_aclk [get_ports s_axi_aclk]

# Set +/- 0.5ns between the rising edges of the clock and sysref
#set_input_delay -clock jd204bv6p0l2sc0_refclk -max 0.4 [get_ports *x_sysref]
#set_input_delay -clock jd204bv6p0l2sc0_refclk -min -0.4 [get_ports *x_sysref]



#set_clock_groups -logically_exclusive -group [get_clocks jd204bv6p0l2sc0_refclk] -group [get_clocks jd204bv6p0l2sc0_axi_aclk]

