#----------------------------------------------------------------------
# Title      : External Clock Constraints for JESD204
# Project    : jesd204_v6_0
#----------------------------------------------------------------------
# File       : jd204bv6p0l2sc0_clocks.xdc
# Author     : Xilinx
#----------------------------------------------------------------------
# Description: Xilinx Constraint file for JESD204 core
#---------------------------------------------------------------------
# (c) Copyright 2004-2013 Xilinx, Inc. All rights reserved.
#

# Set AXI-Lite Clock
set axi_clk  [get_clocks -of_objects [get_ports s_axi_aclk]]

#-----------------------------------------
# Define False Paths
#-----------------------------------------

set_false_path -from [get_cells -hier -filter {name =~ *jesd204_block_i/i_jd204bv6p0l2sc0/i_rx_32/sync_i_reg* && IS_SEQUENTIAL}] -to [get_clocks -of_objects [get_ports s_axi_aclk]]
set_false_path -from [get_cells -hier -filter {name =~ *jesd204_block_i/i_jd204bv6p0l2sc0/i_rx_32/g_rx_lanes[*].i_rx_lane_32/error_seen_reg* && IS_SEQUENTIAL}] -to [get_clocks -of_objects [get_ports s_axi_aclk]]
